/*
	CRACKITA.CPP

   Il programma dato il challenge generato da un nodo ITANET (firmware
   versione 18 by IV3XZF) e la risposta del SYSOP calcola la serie di
   combinazioni coerenti tra cui SICURAMENTE quella esatta da utilizzare
   per entrare in modo SYSOP.

   Questo programma ha origine solo per studio personale dell'autore
   del sistema di protezione adottato nel software ITANET di IV3ZXF.
   Esso vuole essere un contributo per la spinta al perfezionamento
   dei sistemi di protezione e di sicurezza contro gli accessi non
   autorizzati ai sistemi che TROPPO SPESSO E SEMPRE PIU' si verificano
   anche nella rete packet radio radioamatoriale.

   E' proibito l'uso di questo software per l'accesso non autorizzato
   come SYSOP a qualunque sistema della rete ITANET.

   Nessuna responsabilita' diretta o indiretta e' attribuibile all'autore
   in caso di impiego improprio del software.


   Marco Savegnago
   Agosto 1996

   Questa versione e' compilabile con:
   -	BC++ 4.X & STL HP (self modificate per funzionare senza warning e
   								duplicazioni di funzioni)
   -	BC++ 5.X e STL fornite con il compilatore
   -	VC++ 4.X e STL fornite con il compilatore

*/

#include	<iostream.h>
#include	<iomanip.h>

#if defined(__BORLANDC__)
	#if 	(__BORLANDC__ <= 0x462)  // BC++ fino alla 4.53

	#include	<algo.h>
	#include	<vector.h>

	#else									//	BC++  5.0x & VC++

	#include	<algorithm>
	#include	<vector>
	#include 	<numeric>

    using namespace std;

	#endif

#endif

//	Callback per il vector iterator per eseguire la moltiplicazione
//	tra due elementi

int mult (int a, int b)
{
  return a * b;
}

typedef	vector<int>	vect;

void	main()
{
	cout	<<

         "Il programma dato il challenge generato da un nodo ITANET (firmware\n"
         "versione 18 by IV3XZF) e la risposta del SYSOP calcola la serie di\n"
         "combinazioni coerenti tra cui SICURAMENTE quella esatta da utilizzare\n"
         "per entrare in modo SYSOP.\n\n"

         "Questo programma ha origine solo per studio personale dell'autore\n"
         "del sistema di protezione adottato nel software ITANET di IV3ZXF.\n"
         "Esso vuole essere un contributo per la spinta al perfezionamento\n"
         "dei sistemi di protezione e di sicurezza contro gli accessi non\n"
         "autorizzati ai sistemi che TROPPO SPESSO E SEMPRE PIU' si verificano\n"
         "anche nella rete packet radio radioamatoriale.\n\n"

		 "E' proibito l'uso di questo software per l'accesso non autorizzato\n"
         "come SYSOP a qualunque sistema della rete ITANET.\n\n"

         "Nessuna responsabilita' diretta o indiretta e' attribuibile all'autore\n"
         "in caso di impiego improprio del software.\n\n\n"


         "Marco Savegnago\n"
         "Agosto 1996\n"

   		<<	endl;

	const	int	iChallengeLen		=	5;			//	Il numero di elementi del challenge di ITANET
	const	int	iMaxChallegeVal		=	10;		//	Il valore massimo del challenge di ITANET

	vect	challenge(iChallengeLen);				//	Il vettore con il challenge
	vect	sign(iChallengeLen);						//	I segni ricavati dal fatto il numero e' pari o dispari
	vect 	challengeSigned(iChallengeLen);		//	Il challenge segnato
	vect 	saveChallengeSigned(iChallengeLen);	//	Il challenge segnato di backup
	vect 	pwd(iChallengeLen);						//	La password
	vect 	totals(iChallengeLen);					//	I totali

	cout << "Inserire il challenge ITANET (" << iChallengeLen << " numeri, eof per uscire): " ;

	int	i;

	copy(istream_iterator<int,vect::difference_type>(cin),
		istream_iterator<int,vect::difference_type>(),
    		inserter(challenge,challenge.begin()));

	int	total = 0;

	cout << "Inserire risposta del SYSOP :";

	cin 	>>	total;

	//	Imposto il segni delle singole somme (- per pari + per dispari)

	for(i=0;i<(challenge.size());i++)
		sign[i]	=	(challenge[i]%2) ? 1 : -1;

	//	Sommo gli operandi de
	ostream_iterator<int>iter (cout, " ");

	//	Assegno il segno al challenge

	transform(challenge.begin (), challenge.end (), sign.begin(), challengeSigned.begin(), mult);
	cout	<<	"Challenge      : ";
	copy(challenge.begin(), challenge.end(), iter);
	cout	<<	endl;

	//	Salvo il challenge moltiplicato per i segni per utilizzarlo poi

	saveChallengeSigned	= 	challengeSigned;

	cout	<<	"ChallengeSigned  : ";
	copy(challengeSigned.begin(), challengeSigned.end(), iter);
	cout	<<	endl;

	vect temp(iChallengeLen);
	int	supposeTotal;

	int		nFound=0;

	fill(temp.begin(), temp.end(), 0);

	long	lIteration=0;

	for(int a=0;a<iMaxChallegeVal;a++)
	{
		temp[0]	=	a;
		for(int b=0;b<iMaxChallegeVal;b++)
		{
			temp[1]	=	b;
			for(int c=0;c<iMaxChallegeVal;c++)
			{
				temp[2]	=	c;
				for(int d=0;d<iMaxChallegeVal;d++)
				{
					temp[3]	=	d;

					for(int e=0;e<iMaxChallegeVal;e++)
					{
						lIteration++;

						temp[4]	=	e;
						transform(saveChallengeSigned.begin(), saveChallengeSigned.end(), temp.begin(), totals.begin(), mult);
						supposeTotal	=	accumulate(totals.begin(), totals.end(),0);

						if(total==supposeTotal)
						{
							nFound++;
							cout	<<	"Combinazione valida(" << nFound << ") :";
							copy(temp.begin(), temp.end(), iter);
							cout	<<	endl;
						}
					}
				}
			}
		}
	}

	cout	<<	"Numero di iterazioni: 	" <<	lIteration << endl;

	if(nFound)
		cout	<<	"Trovate " << nFound << " combinazioni" << endl;
	else
		cout	<<	"Nessuna combinazione (verificare i dati)" << endl;
}

